



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>bzoj4031 [HEOI2015]小Z的房间</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">bzoj4031 [HEOI2015]小Z的房间</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 22:50:37 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>Description</h2>
<div>
<p>你突然有了一个大房子，房子里面有一些房间。事实上，你的房子可以看做是一个包含n*m个格子的格状矩形，每个格子是一个房间或者是一个柱子。在一开始的时候，相邻的格子之间都有墙隔着。</p>
<div>你想要打通一些相邻房间的墙，使得所有房间能够互相到达。在此过程中，你不能把房子给打穿，或者打通柱子（以及柱子旁边的墙）。同时，你不希望在房子中有小偷的时候会很难抓，所以你希望任意两个房间之间都只有一条通路。现在，你希望统计一共有多少种可行的方案。</div>
</div>
<h2>Input</h2>
<div>
<p>第一行两个数分别表示n和m。</p>
<div>接下来n行，每行m个字符，每个字符都会是&rsquo;.&rsquo;或者&rsquo;*&rsquo;，其中&rsquo;.&rsquo;代表房间，&rsquo;*&rsquo;代表柱子。</div>
</div>
<h2>Output</h2>
<div>
<p>一行一个整数，表示合法的方案数 Mod 10^9</p>
</div>
<h2>Sample Input</h2>
<div>3 3<br />
...<br />
...<br />
.*.
</div>
<h2>Sample Output</h2>
<div>15</div>
<h2>HINT</h2>
<p>对于前100%的数据，n,m&lt;=9</p>
<p>正解：矩阵树定理+高斯消元。</p>
<p>$Matrix-Tree$定理</p>
<p>1、$G$的度数矩阵$\({D_G}\)$是一个$n*n$的矩阵，并且满足：当$i&ne;j$时,$\({D_{i,j}}\)=0$；当$i=j$时，$\({D_{i,j}}\)$等于$\({V_{i}}\)$的度数。<br />
2、$G$的邻接矩阵$\({A_{G}}\)$也是一个$n*n$的矩阵，并且满足：如果$\({V_{i}}\)$、$\({V_{j}}\)$之间有边直接相连，则$\({A_{i,j}}\)=1$，否则为$0$。<br />
定义$G$的$Kirchhoff$矩阵$\(C_G\)$为$\(C_G=D_G-A_G\)$<br />
$Matrix-Tree$定理：$G$的所有不同的生成树的个数等于其$Kirchhoff$矩阵$\(C_G\)$任何一个$n-1$阶主子式（去掉第$r$行第$r$列的新矩阵）的行列式的绝对值。</p>
<p>这题有一个麻烦的地方在于：模数不是质数。所以我们不能直接求逆元。但是我们可以用欧几里得定理，直接辗转相除就行了。</p>
<div>
<pre class="prettyprint linenums"> //It is made by wfj_2048~<br />
 #include &lt;algorithm&gt;<br />
 #include &lt;iostream&gt;<br />
 #include &lt;complex&gt;<br />
 #include &lt;cstring&gt;<br />
 #include &lt;cstdlib&gt;<br />
 #include &lt;cstdio&gt;<br />
 #include &lt;vector&gt;<br />
 #include &lt;cmath&gt;<br />
 #include &lt;queue&gt;<br />
 #include &lt;stack&gt;<br />
 #include &lt;map&gt;<br />
 #include &lt;set&gt;<br />
 #define rhl (1000000000)<br />
 #define inf (1&lt;&lt;30)<br />
 #define il inline<br />
 #define RG register<br />
 #define ll long long<br />
 #define File(s) freopen(s".in","r",stdin),freopen(s".out","w",stdout)

 using namespace std;

 ll a[][],d[][],g[][],c[][],n,m,cnt,ans;<br />
 char s[][];

 il void insert(RG ll x,RG ll y){ g[x][y]=,d[x][x]++; return; }

 il void gauss(){<br />
     RG ll f=;<br />
     for (RG ll i=;i&lt;cnt;++i){<br />
     for (RG ll j=i+;j&lt;cnt;++j){<br />
         RG ll x=a[i][i],y=a[j][i];<br />
         while (y){<br />
         RG ll t=x/y; x%=y; swap(x,y);<br />
         for (RG ll k=i;k&lt;cnt;++k){<br />
             a[i][k]=(a[i][k]-t*a[j][k]%rhl+rhl)%rhl;<br />
             swap(a[i][k],a[j][k]);<br />
         }<br />
         f=-f;<br />
         }<br />
     }<br />
     if (!a[i][i]){ ans=; return; }<br />
     ans=ans*a[i][i]%rhl;<br />
     }<br />
     if (f==-) ans=(rhl-ans)%rhl; return;<br />
 }

 il void work(){<br />
     cin&gt;&gt;n&gt;&gt;m,ans=;<br />
     for (RG ll i=;i&lt;=n;++i){<br />
     scanf("%s",s[i]+);<br />
     for (RG ll j=;j&lt;=m;++j)<br />
         if (s[i][j]=='.') c[i][j]=++cnt;<br />
     }<br />
     for (RG ll i=;i&lt;=n;++i)<br />
     for (RG ll j=;j&lt;=m;++j){<br />
         if (s[i][j]=='*') continue;<br />
         if (i-&gt; &amp;&amp; s[i-][j]=='.') insert(c[i][j],c[i-][j]);<br />
         if (i+&lt;=n &amp;&amp; s[i+][j]=='.') insert(c[i][j],c[i+][j]);<br />
         if (j-&gt; &amp;&amp; s[i][j-]=='.') insert(c[i][j],c[i][j-]);<br />
         if (j+&lt;=m &amp;&amp; s[i][j+]=='.') insert(c[i][j],c[i][j+]);<br />
     }<br />
     for (RG ll i=;i&lt;=cnt;++i)<br />
     for (RG ll j=;j&lt;=cnt;++j) a[i][j]=(d[i][j]-g[i][j]+rhl)%rhl;<br />
     gauss(); printf("%lld",ans); return;<br />
 }

 int main(){<br />
     File("room");<br />
     work();<br />
     return ;<br />
 }</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/0qw0d397.html">信息安全－1：python之playfair密码算法详解&lbrack;原创&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93pdkr8.html">pygame开发PC端微信打飞机游戏</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2gj4w8.html">Sql Server 常用操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8m47j08.html">h5移动端前端性能优化</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnepzgq.html">&lpar;5&rpar; 深入理解Java Class文件格式&lpar;四&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnxk4g9.html">jquery星级评论打分组件</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv5x6xq.html">Python import 指定目录中的模块</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxn20kv8.html">【Exception】  java&period;lang&period;NoSuchMethodError&colon; android&period;app&period;AlertDialog&dollar;Builder&period;setOnDismissListener</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1dwe28.html">poj 3255&lpar;次短路&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdjomd8.html">关于switch的思考和总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/950z70z8.html">201521123023《Java程序设计》第8周学习总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/96p45ov8.html">JIRA 敏捷开发平台部署记录</a>
		</li>
						<li><a href="https://www.batexi.com/a/96p4xl48.html">那些年原生js实现的楼层跳转</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj617e9.html">Android应用市场的帮助类</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwmn578.html">基于 Token 的身份验证：JSON Web Token（附：Node&period;js 项目）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4j7vj5q.html">laravel路由别名</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5kl47q.html">Alpha冲刺 - &lpar;5&sol;10&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1gwxw9.html">AtCoder Regular Contest 063 F &colon; Snuke&rsquo;s Coloring 2 &lpar;线段树 &plus; 单调栈&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j16o6e9.html">复习下C 链表操作（双向循环链表，查找循环节点）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx2dxld8.html">jquery ajax context</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9rg0kz48.html">&period;Net程序员学用Oracle系列&lpar;22&rpar;：分析函数&lpar;OVER&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4zn33j9.html">Caliburn&period;Micro - 框架搭建</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy1r07jq.html">JavaWeb之Listener监听器</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv10wdyq.html">js简单省级联动菜单</a>
			</li>
						<li><a href="https://www.batexi.com/a/96p5n2v8.html">web之Respone</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pdx4k79.html">Python之路-基本数据类型</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlj5r7e9.html">Activiti的全局事件机制及其监听处理</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pdxrx79.html">4&period;在浏览器中解析XML</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zojw5nq.html">收集下shell使用笔记</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mep12pq.html">4日6日--ES5新增数组方法</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
